#include <stdio.h>

int baza(unsigned n, double* p)
{
    int b, npom, bmin, brznam;
    double prosznammin, prosznam, razmin, raztemp;

    bmin=n+1;  /*n+1 je najmanji b za koji je n jednoznamenkasti i on sigurno nece biti optimalan jer je p<n/2*/
    prosznammin=n;
    razmin=(prosznam-*p>0?prosznam-*p:*p-prosznam);

    for(b=2;b<=n;b++){
        npom=n;  /*da ne izgubimo vrijednost od n*/
        prosznam=0;
        brznam=0;
        while(npom>0){
            prosznam+=npom%b;
            npom/=b;
            brznam++;
        }
        prosznam/=brznam;
        raztemp=(prosznam-*p>0?prosznam-*p:*p-prosznam);
        if(raztemp<razmin){
            prosznammin=prosznam;
            razmin=raztemp;
            bmin=b;
        }
    }
    *p=prosznammin;

    return bmin;
}

int main(void)
{
    int b;
    unsigned n=62;
    double p=30.5;

    b=baza(n,&p);

    printf("Najbliza prosjecna vrijednost je %g, u bazi %d\n\n", p, b);

    return 0;
}
